import greenfoot.*;
import packages.geometry.Vector2D;
public class CirclePainter extends Painter {
    
    
    public CirclePainter(Painting painting) {
        super(painting);
    }
    public CirclePainter() {
        this(null);
    }


    @Override
    public void updateImage(int size) {
        GreenfootImage image = new GreenfootImage(size, size);
        image.setColor(Color.GRAY);
        image.drawOval(0, 0, size - 1, size - 1);
        setImage(image);
    }


    @Override
    public void paint(int startX, int startY, int endX, int endY, int size, Color color, GreenfootImage image) {

        int difX = endX - startX, difY = endY - startY;
        int length = (int)Math.hypot(difX, difY);
        GreenfootImage line = new GreenfootImage(length + size, length + size);

        line.setColor(color);
        line.fillOval(0, length / 2, size - 1, size - 1);
        line.fillOval(length, length / 2, size - 1, size - 1);
        line.fillRect(size / 2, length / 2, length, size);

        double angle = new Vector2D(difX, difY).angle();
        line.rotate((int)angle);
        setRotation((int)angle);

        image.drawImage(line, startX + difX / 2 - (length + size) / 2, startY + difY / 2 - (length + size) / 2);
    }
}